unit UBoolParser;

interface

uses
  Windows, Classes, SysUtils, afParser11;

type
  TBoolParser = class(TParser)
  private
    function CalcBool: BOOL;

  public
    constructor Create(AOwner: TComponent); override;

  published
    property Bool: BOOL read CalcBool stored false;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Samples', [TBoolParser]);
end;

procedure _greater(AnOp: POperation); far;
begin
  with AnOp^ do
    if arg1^ > arg2^ then
      dest^ := 1
    else
      dest^ := 0;
end;

procedure _smaller(AnOp: POperation); far;
begin
  with AnOp^ do
    if arg1^ < arg2^ then
      dest^ := 1
    else
      dest^ := 0;
end;

procedure _or(AnOp: POperation); far;
begin
  with AnOp^ do
    if (arg1^ > 0) or (arg2^ > 0) then
      dest^ := 1
    else
      dest^ := 0;
end;

procedure _and(AnOp: POperation); far;
begin
  with AnOp^ do
    if (arg1^ > 0) and (arg2^ > 0) then
      dest^ := 1
    else
      dest^ := 0;
end;

procedure _xor(AnOp: POperation); far;
begin
  with AnOp^ do
    if (arg1^ > 0) and (arg2^ > 0) then
      dest^ := 1
    else
      dest^ := 0;
end;

procedure _equal(AnOp: POperation); far;
begin
  with AnOp^ do
    if arg1^ = arg2^ then
      dest^ := 1
    else
      dest^ := 0;
end;

procedure _notequal(AnOp: POperation); far;
begin
  with AnOp^ do
    if arg1^ <> arg2^ then
      dest^ := 1
    else
      dest^ := 0;
end;

procedure _not(AnOp: POperation); far;
begin
  with AnOp^ do
    if (arg1^ > 0) then
      dest^ := 0
    else
      dest^ := 1;
end;

{ TBoolParser }

function TBoolParser.CalcBool: BOOL;
begin
  Result := (Value <> 0);
end;

constructor TBoolParser.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);

  FunctionTwo.AddObject('GREATER', TObject(@_greater));
  FunctionTwo.AddObject('SMALLER', TObject(@_smaller));
  FunctionTwo.AddObject('OR', TObject(@_or));
  FunctionTwo.AddObject('AND', TObject(@_and));
  FunctionTwo.AddObject('XOR', TObject(@_xor));
  FunctionTwo.AddObject('EQUAL', TObject(@_equal));
  FunctionTwo.AddObject('NOTEQUAL', TObject(@_notequal));
  FunctionOne.AddObject('NOT', TObject(@_not))
end;

end.
